--- ChangeLog	2005/05/26 22:01:34	1.3
+++ ChangeLog	2005/05/28 08:43:50
@@ -1,3 +1,7 @@
+2005-05-27  Joerg Hoehle <hoehle@users.sourceforge.net>
+
+	* swank-clisp.lisp (getpid): Use defimplementation.
+
 2005-05-26  Joerg Hoehle <hoehle@users.sourceforge.net>
 
 	* swank.lisp (present-symbol-before-p): make it conform to its
@@ -10,7 +14,7 @@
 	operators from functions.
 	* slime.el (slime-print-apropos): Must keep in sync with above,
 	therefore added :macro and :special-operator properties.
-	
+
 2005-04-27  Helmut Eller  <heller@common-lisp.net>
 
 	* swank-cmucl.lisp (+header-type-symbols+): Drop the third arg to
--- swank-clisp.lisp	2005/05/26 14:31:27	1.2
+++ swank-clisp.lisp	2005/05/28 08:38:39
@@ -32,7 +32,7 @@
   (when (find-package "LINUX")
     (pushnew :linux *features*)))
 
-;;;; if this listp has the complete CLOS then we use it, othewise we
+;;;; if this lisp has the complete CLOS then we use it, otherwise we
 ;;;; build up a "fake" swank-mop and then overide the methods in the
 ;;;; inspector.
 
@@ -42,7 +42,7 @@
          (eql :external
               (nth-value 1 (find-symbol (string ':standard-slot-definition)
 					:clos))))
-    "True in those CLISP imagse which have a complete MOP implementation."))
+    "True in those CLISP images which have a complete MOP implementation."))
 
 #+#.(cl:if swank-backend::*have-mop* '(cl:and) '(cl:or))
 (progn
@@ -80,20 +80,12 @@
 (defimplementation call-without-interrupts (fn)
   (funcall fn))
 
-#+unix 
-(defmethod getpid () 
-  (funcall (or (find-symbol "PROGRAM-ID" :system)
- 	       (find-symbol "PROCESS-ID" :system)
- 	       (error "getpid not implemented"))))
-
-#+win32 
-(defmethod getpid ()
-  (cond ((find-package :win32)
-	 (funcall (find-symbol "GetCurrentProcessId" :win32)))
-	(t
-	 (system::getenv "PID"))))
-
-;; the above is likely broken; we need windows NT users!
+(let ((getpid (or (find-symbol "PROCESS-ID" :system)
+		  ;; old name prior to May 2005, clisp <= 2.33.2
+		  (find-symbol "PROGRAM-ID" :system))))
+  (when getpid
+    (defimplementation getpid ()
+      (funcall getpid))))
 
 (defimplementation lisp-implementation-type-name ()
   "clisp")
